// Effect.h: interface for the CEffect class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EFFECT_H__351D0D73_105F_477E_A6FB_E3B00D61AEB9__INCLUDED_)
#define AFX_EFFECT_H__351D0D73_105F_477E_A6FB_E3B00D61AEB9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#import "PanObj.tlb" raw_interfaces_only no_namespace
//using namespace PANOBJLib;

#include <vector>
#include "StringProp.h"
#include "FontInfo.h"
#include "ViewWindow.h"
#include "WindowVirt.h"

class CEffect  
{
public:
	CEffect();
    CEffect(CWindowVirt* winUI,
            CComQIPtr<IPanImage>       img,
            std::vector<CStringProp*>* propVec,
            std::vector<CFontProp*>*   propFontVec,
            LPTSTR progID,
            CViewWindow* pView,
            HWND hWndMain);
	virtual ~CEffect();

    void Close();
    void Save();

    // the filename associated with an effect is
    // where the effect settings are to be persisted.
    // 
    // A newly created effect won't have a filename assoc.
    // with it, so the host of an effect is required to
    // use GetFileName() to determine whether to interpret
    // a Save command as a SaveAs.
    LPCTSTR GetFileName();
    void SetFileName(LPTSTR f);

    HWND GetHWND() { return *m_win; }

    void SetMainHWND(HWND hWnd) { m_hWndMain = hWnd; }

    CViewWindow* GetViewWindow() { return m_view; }

private:
    LPTSTR m_fName;
    CComQIPtr<IPanImage> m_image;
    CWindowVirt* m_win;
    LPTSTR m_progID;
    std::vector<CStringProp*>* m_propVec;
    std::vector<CFontProp*>*   m_propFontVec;
    CViewWindow* m_view;
    HWND         m_hWndMain;
};

#endif // !defined(AFX_EFFECT_H__351D0D73_105F_477E_A6FB_E3B00D61AEB9__INCLUDED_)
