// PanFactory.h: interface for the CPanFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANFACTORY_H__65EA0427_744C_4B6D_A097_E69366FC5B4B__INCLUDED_)
#define AFX_PANFACTORY_H__65EA0427_744C_4B6D_A097_E69366FC5B4B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#import "PanObj.tlb" raw_interfaces_only no_namespace
//using namespace PANOBJLib;

#include "PanDisp.h"
typedef void (*InvalidProc)();
#include "UISpec.h"
#include "StringProp.h"
#include "FontInfo.h"
#include "PerfData.h"
#include "ViewWindow.h"
#include "WindowVirt.h"
#include "ViewInvalidator.h"
#include "MouseUpdater.h"
#include <vector>

//
// CLASS: CPanFactory
//
// PURPOSE: Given an interface pointer to a PanImage, CPanFactory
//          instantiates the PanImage's UI and sets it off running.
// 
class CPanFactory  
{
public:
	CPanFactory(CComQIPtr<IPanImage> pImage,
                int *pDisplayPasses,
                double *pMaxJitter,
                CComBSTR docURL);
	virtual ~CPanFactory();

    CWindowVirt*
        Create(HWND hWnd,
                std::vector<CStringProp*>* pProp,
                std::vector<CFontProp*>* pPropFont,
                CPerfData* pData,
                CViewWindow** pView);

    void UpdateMousePos(float x, float y) {
        m_mouseUpdater->UpdateMousePos(x,y);
    }

protected:
    CWindowVirt* CreateUI(HWND hWndParent, UI* pUI);

    CComQIPtr<IPanImage> m_imagePtr;
    int *m_pDisplayPasses; double *m_pMaxJitter; // for multi-pass display
    CComBSTR m_docURL;

    // Instead of passing some state as arguments to CreateUI, we
    // opt to store them as fields in the object & fish them out when needed.
    // Tidies up the calling interface of CreateUI() a little.

    std::vector<CStringProp*>* m_stringProp;
    std::vector<CFontProp*>*   m_fontProp;
    CViewWindow** m_pView;
    CPerfData* m_perfData;
    CViewInvalidator* m_viewInvalidator;
    CMouseUpdater* m_mouseUpdater;


};

#endif // !defined(AFX_PANFACTORY_H__65EA0427_744C_4B6D_A097_E69366FC5B4B__INCLUDED_)
