// PanSlider.h: interface for the CPanSlider class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANSLIDER_H__59FF50FD_B487_4343_9947_09834B14B6D6__INCLUDED_)
#define AFX_PANSLIDER_H__59FF50FD_B487_4343_9947_09834B14B6D6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Slider.h"
#include "PanDisp.h"
#import "PanObj.tlb" raw_interfaces_only no_namespace
#include "UISpec.h"
#include "Invalidator.h"

class CPanSlider : public CSlider  
{
public:
	CPanSlider
           ( HWND hWndParent
	       , LPCTSTR  label
	       , float min
	       , float max
           , FloatUpdater* pUpd
           , void* pParam
	       , CInvalidator* pInvalid
	       );
	virtual ~CPanSlider();

    BEGIN_MSG_MAP(CPanSlider)
        MESSAGE_HANDLER(WM_HSCROLL, OnHScroll)
        COMMAND_CODE_HANDLER(EN_CHANGE, OnChange)
        CHAIN_MSG_MAP(CSlider)
    END_MSG_MAP()

    LRESULT OnHScroll(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

private:
    float               m_min, m_max;
    float               m_value;
    FloatUpdater*       m_updateValue;
    void*               m_pParam;
    CInvalidator*   m_iProc;
    bool                m_inFlux;

};

#endif // !defined(AFX_PANSLIDER_H__59FF50FD_B487_4343_9947_09834B14B6D6__INCLUDED_)
